#include<iostream>
#include<stdlib.h>
#include<cmath>
#include<sstream>
#include<fstream>
#include<string>
#include<iomanip>
#include<vector>


using namespace std;

const double PI  = 3.141592653589793238462;

int k=0;
int Kmax;
int Kstart = 0;

const int Tmax=2500;
const int Nmax=100;
const int Nbeadsmax=500;

int N,Nbeads;
int DeltaT=100;
double dt=0.01;
double Lx,Ly,Lz;

//
double xMSDRing[Nmax][Tmax];
double yMSDRing[Nmax][Tmax];
double zMSDRing[Nmax][Tmax];
double xMSD[Tmax];
double yMSD[Tmax];
double zMSD[Tmax];
double xDIS[Tmax];
double yDIS[Tmax];
double zDIS[Tmax];
double xCOM[Tmax];
double yCOM[Tmax];
double zCOM[Tmax];

//positions
vector<double> v1(Tmax,0);
vector<vector <double> > v2(Nbeadsmax,v1);
vector<vector<vector <double> > > xpos(Nmax,v2);
vector<vector<vector <double> > > ypos(Nmax,v2);
vector<vector<vector <double> > > zpos(Nmax,v2);

double position[Nmax][Nbeadsmax][3];

double g2Ring[Nmax][Tmax][3];
double g2[Tmax][3];
double g1Ring[Nmax][Tmax][3];
double g1[Tmax][3];

double xCOMRing[Nmax][Tmax];
double yCOMRing[Nmax][Tmax];
double zCOMRing[Nmax][Tmax];


int main(int argc, char* argv[]){
srand(time(NULL));

cout << "Write argv[1]: datain; argv[2] = dataout; argv[3]=Tmax; argv[4]:N argv[5]:Nbeads; argv[6]=DeltaT"<< endl;
cout << "Num of files to convert:";
Kmax=int(atoi(argv[3]));
cout<<"Number of polyms:";
N=int(atoi(argv[4]));
cout<<"Number of beads p polymer:";
Nbeads=int(atoi(argv[5]));
cout<<"DeltaT:";
DeltaT=int(atoi(argv[6]));
	
for(int n=0;n<Tmax;n++) xMSD[n] = yMSD[n] = zMSD[n] = xCOM[n] = yCOM[n] = zCOM[n] = 0;
for(int n=0;n<Tmax;n++) for(int d=0;d<3;d++)g1[n][d]=g2[n][d]=0;
for(int n=0;n<Tmax;n++) for(int m=0;m<Nmax;m++)  for(int d=0;d<3;d++)g1Ring[m][n][d]=g2Ring[m][n][d]=0;

stringstream writeFileMSD;
writeFileMSD <<"g3_"<<argv[2];
ofstream writeMSD(writeFileMSD.str().c_str());
writeMSD << "#t[t_LJ]\tg3"<< endl;

stringstream writeFileg1;
writeFileg1 <<"g1_"<<argv[2];
ofstream writeg1(writeFileg1.str().c_str());
writeg1 << "#t[t_LJ]\tg1"<< endl;

stringstream writeFileg2;
writeFileg2 <<"g2_"<<argv[2];
ofstream writeg2(writeFileg2.str().c_str());
writeg2 << "#t[t_LJ]\tg2"<< endl;

	
/////////////////////////////////////////////////////
//MAIN LOOP OVER TIME!!!
////////////////////////////////////////////////////
for(k=0;k<Kmax;k++){

ifstream indata;
stringstream readFile;
readFile.str("");
readFile.clear();
long long int sum = int((k+Kstart));
if(sum==0) readFile << argv[1] <<sum;
if(sum>0 && DeltaT==100)readFile << argv[1] <<sum << "00";
if(sum>0 && DeltaT==1000)readFile << argv[1] <<sum << "000";
if(sum>0 && DeltaT==10000)readFile << argv[1] <<sum << "0000";
indata.open(readFile.str().c_str());
cout << readFile.str().c_str()<<endl;
if(!indata){cout <<"file "<< readFile.str().c_str() << " is not there"<<endl; return 0;}

long int id,type,mol;
double num1,num2,num3;
double x,y,z;
string dummy;
long long int time;
long int Ntot;
double l1,l2;

//read 10 lines
for(int i=0;i<10;i++){
if(i==1) {
indata >> time;
time = k*DeltaT*dt;
cout << "time " << time <<endl;
}
if(i==3) {
indata >> Ntot;
cout << "Ntot " << Ntot<<endl;
}
if(i==5) {
indata >> l1 >> l2;
cout << "L " << l1<< " " << l2 <<endl;
Lx = l2-l1;
cout << "Lx " << Lx <<endl;
}
if(i==6) {
indata >> l1 >> l2;
cout << "L " << l1<< " " << l2 <<endl;
Ly = l2-l1;
cout << "Ly " << Ly <<endl;
}
if(i==7) {
indata >> l1 >> l2;
cout << "L " << l1<< " " << l2 <<endl;
Lz = l2-l1;
cout << "Lz " << Lz<<endl;
}

else getline(indata,dummy);
cout << dummy<<endl;
}
 
//////////////////////////
//READ FILES
////////////////////////////
for(int n=0; n<Ntot; n++){

    //indata >> id>>  x>>y>>z>>num1>>num2>>num3;
    indata >> id>>type>>x>>y>>z>>num1>>num2>>num3;
	//cout << "type! " << id << " " << type <<endl; //cin.get();
	int Nring=floor((id-1)*1.0/Nbeads);
	int idx=(id-1)%Nbeads;
	
	xpos[Nring][idx][k]=(x + Lx*num1);
	ypos[Nring][idx][k]=(y + Ly*num2);
	zpos[Nring][idx][k]=(z + Lz*num3);

	xCOMRing[Nring][k]+=(x + Lx*num1)*1.0/Nbeads;
	yCOMRing[Nring][k]+=(y + Ly*num2)*1.0/Nbeads;
	zCOMRing[Nring][k]+=(z + Lz*num3)*1.0/Nbeads;

}
	
}//closes time (loop over k)

long int tau=0.0;
for(tau=0;tau<Kmax;tau++){ //lag time
//if(tau%kgap==0){
cout << "tau " << tau <<endl;
writeg1 << tau*DeltaT*dt <<" ";
writeg2 << tau*DeltaT*dt <<" ";
writeMSD << tau*DeltaT*dt <<" ";

//////////////////////////////////////////////////
///////// COM	 	//////////////////////////
//////////////////////////////////////////////////
	for(int n=0;n<N;n++){
		int Kave=Kmax-tau;
		for(int t=0;t<Kave;t++){
		xMSDRing[n][tau]+=pow(xCOMRing[n][t+tau]-xCOM[t+tau]-(xCOMRing[n][t]-xCOM[t]),2.0)*1.0/(Kave);
		yMSDRing[n][tau]+=pow(yCOMRing[n][t+tau]-yCOM[t+tau]-(yCOMRing[n][t]-yCOM[t]),2.0)*1.0/(Kave);
		zMSDRing[n][tau]+=pow(zCOMRing[n][t+tau]-zCOM[t+tau]-(zCOMRing[n][t]-zCOM[t]),2.0)*1.0/(Kave);
		}
	writeMSD <<  (xMSDRing[n][tau]+yMSDRing[n][tau]+zMSDRing[n][tau])<<" ";
	xMSD[tau]+=xMSDRing[n][tau]*1.0/N;
	yMSD[tau]+=yMSDRing[n][tau]*1.0/N;
	zMSD[tau]+=zMSDRing[n][tau]*1.0/N;

//////////////////////////////////////////////////
///////// SINGLE BEADS 	//////////////////////////
//////////////////////////////////////////////////
	for(int m=0;m<Nbeads;m++){
		int Kave=Kmax-tau; //1
		for(int t=0;t<Kave;t++){
		//// g1 ////////////
		g1Ring[n][tau][0]+=pow(xpos[n][m][t+tau]-xCOM[t+tau]-xpos[n][m][t]+xCOM[t],2.0)*1.0/(Kave*Nbeads);
		g1Ring[n][tau][1]+=pow(ypos[n][m][t+tau]-yCOM[t+tau]-ypos[n][m][t]+yCOM[t],2.0)*1.0/(Kave*Nbeads);
		g1Ring[n][tau][2]+=pow(zpos[n][m][t+tau]-zCOM[t+tau]-zpos[n][m][t]+zCOM[t],2.0)*1.0/(Kave*Nbeads);
		//// g2 ////////////
		g2Ring[n][tau][0]+=pow(xpos[n][m][t+tau]-xCOMRing[n][t+tau]-xpos[n][m][t]+xCOMRing[n][t],2.0)*1.0/(Kave*Nbeads);
		g2Ring[n][tau][1]+=pow(ypos[n][m][t+tau]-yCOMRing[n][t+tau]-ypos[n][m][t]+yCOMRing[n][t],2.0)*1.0/(Kave*Nbeads);
		g2Ring[n][tau][2]+=pow(zpos[n][m][t+tau]-zCOMRing[n][t+tau]-zpos[n][m][t]+zCOMRing[n][t],2.0)*1.0/(Kave*Nbeads);
		}
		
	}
	g1[tau][0]+=g1Ring[n][tau][0]*1.0/N;
	g1[tau][1]+=g1Ring[n][tau][1]*1.0/N;
	g1[tau][2]+=g1Ring[n][tau][2]*1.0/N;
	g2[tau][0]+=g2Ring[n][tau][0]*1.0/N;
	g2[tau][1]+=g2Ring[n][tau][1]*1.0/N;
	g2[tau][2]+=g2Ring[n][tau][2]*1.0/N;
		
	writeg1 <<  (g1Ring[n][tau][0]+g1Ring[n][tau][1]+g1Ring[n][tau][2])<<" ";
	writeg2 <<  (g2Ring[n][tau][0]+g2Ring[n][tau][1]+g2Ring[n][tau][2])<<" ";
	}

writeMSD << xMSD[tau]+yMSD[tau]+zMSD[tau]<<endl;
writeg1 << g1[tau][0]+g1[tau][1]+g1[tau][2]<<endl;
writeg2 << g2[tau][0]+g2[tau][1]+g2[tau][2]<<endl;

}


return 0 ;
}


